<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TechnicalStop ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TechnicalStop extends AbstractStructArrayBase
{
    /**
     * The TechnicalStop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TechnicalStop[]
     */
    public $TechnicalStop;
    /**
     * Constructor method for ArrayOfJP_TechnicalStop
     * @uses ArrayOfJP_TechnicalStop::setTechnicalStop()
     * @param \StructType\JP_TechnicalStop[] $technicalStop
     */
    public function __construct(array $technicalStop = array())
    {
        $this
            ->setTechnicalStop($technicalStop);
    }
    /**
     * Get TechnicalStop value
     * @return \StructType\JP_TechnicalStop[]|null
     */
    public function getTechnicalStop()
    {
        return $this->TechnicalStop;
    }
    /**
     * This method is responsible for validating the values passed to the setTechnicalStop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTechnicalStop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTechnicalStopForArrayConstraintsFromSetTechnicalStop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TechnicalStopTechnicalStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TechnicalStopTechnicalStopItem instanceof \StructType\JP_TechnicalStop) {
                $invalidValues[] = is_object($arrayOfJP_TechnicalStopTechnicalStopItem) ? get_class($arrayOfJP_TechnicalStopTechnicalStopItem) : sprintf('%s(%s)', gettype($arrayOfJP_TechnicalStopTechnicalStopItem), var_export($arrayOfJP_TechnicalStopTechnicalStopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TechnicalStop property can only contain items of type \StructType\JP_TechnicalStop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TechnicalStop value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TechnicalStop[] $technicalStop
     * @return \ArrayType\ArrayOfJP_TechnicalStop
     */
    public function setTechnicalStop(array $technicalStop = array())
    {
        // validation for constraint: array
        if ('' !== ($technicalStopArrayErrorMessage = self::validateTechnicalStopForArrayConstraintsFromSetTechnicalStop($technicalStop))) {
            throw new \InvalidArgumentException($technicalStopArrayErrorMessage, __LINE__);
        }
        $this->TechnicalStop = $technicalStop;
        return $this;
    }
    /**
     * Add item to TechnicalStop value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TechnicalStop $item
     * @return \ArrayType\ArrayOfJP_TechnicalStop
     */
    public function addToTechnicalStop(\StructType\JP_TechnicalStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TechnicalStop) {
            throw new \InvalidArgumentException(sprintf('The TechnicalStop property can only contain items of type \StructType\JP_TechnicalStop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TechnicalStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TechnicalStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TechnicalStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TechnicalStop
     */
    public function getAttributeName()
    {
        return 'TechnicalStop';
    }
}
